<?php

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function do_ip_lookup($domain, $subdomain="www")
{
	$host = idn_convert_to_host_name($domain, $subdomain);
	
	$ip = gethostbyname($host);
	if($ip != $host)
	{
		$data_array['ip'] = $ip;
		do_ip_asn_lookup($ip, $data_array);
	}
	else
		$data_array['ip'] = "error";
	$data_array['ip_checked_at'] = date("Y-m-d H:i:s");
	update_domain_table($data_array, $domain);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function do_ip_asn_lookup($ip, &$data_array)
{
	$blocks = explode('.', trim($ip));
	if(is_array($blocks))
	{
		if(count($blocks) == 4)
		{
			$host = $blocks[3] . "." . $blocks[2] . "." . $blocks[1] . "." . $blocks[0] . ".origin.asn.cymru.com";
			$result = dns_get_record($host , DNS_TXT);
			//print_r($result);
			if(isset($result[0]['txt']))
			{
				$entries = $result[0]['txt']; 
				$blocks = explode('|', $entries);
				if(is_array($blocks))
				{
					$asnum = "AS" . trim($blocks[0]);
					$data_array['ip_asnumber'] = $asnum;
					$result = dns_get_record($asnum . ".asn.cymru.com", DNS_TXT);
					//print_r($result);
					if(isset($result[0]['txt']))
					{
						$blocks = explode("|", $result[0]['txt']); 
						$count = count($blocks);
						$asname = trim($blocks[$count-1]);
						$dashpos = strpos($asname, " - ");
						if($dashpos > 0)
						{
							$asname = substr($asname, 0, $dashpos);
						}
						$data_array['ip_asname'] = $asname;
						//echo $asname . "\n";
					}	
				}
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

?>
