<?php

/////////////////////////////////////////////////////////////////////////////////////////

function openssl_to_timestamp ($in) 
{
	$year  = substr($in, 0, 2); /* NOTE: Yes, this returns a two digit year */
	$month = substr($in, 2, 2);
	$day   = substr($in, 4, 2);
	$hour  = substr($in, 6, 2);
	$min   = substr($in, 8, 2);
	$sec   = substr($in, 10, 2);
	return gmmktime($hour, $min, $sec, $month, $day, $year);
}

/////////////////////////////////////////////////////////////////////////////////////////

function get_all_ssl_records($domain, $spit_out=false)
{
	$sid = get_sid_from_domain_name($domain);
	global $db_config_subdomain_table;
	$sql = "select subdomain from " . $db_config_subdomain_table . " where sid = $sid";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	while($row = mysql_fetch_array($idresults,MYSQL_ASSOC)) 
	{
		$host = $row['subdomain'];
		get_ssl_records($host, $domain, $spit_out);
	}
}
 
/////////////////////////////////////////////////////////////////////////////////////////

function get_ssl_records($host, $domain, $spit_out=false)
{
	$hostname = idn_convert_to_host_name($domain, $host);
	$ip = gethostbyname($hostname);
	if($ip != $hostname)
		$data_array['ip'] = $ip;
	else
		$data_array['ip'] = "error";
	$data_array['ip_checked_at'] = date("Y-m-d H:i:s");
	$data_array['hostname'] = $hostname;
	
	$get = @stream_context_create(array("ssl" => array("capture_peer_cert" => TRUE)));
	$read = @stream_socket_client("ssl://" . $hostname . ":443", $errno, $errstr, 30, STREAM_CLIENT_CONNECT, $get);
	if($read != false)
	{
		$cert = stream_context_get_params($read);
		$certd = $cert["options"]["ssl"]["peer_certificate"];
		$parsed = openssl_x509_parse($cert["options"]["ssl"]["peer_certificate"]);
		
		if(isset($parsed['validFrom']))
			$data_array['ssl_valid_from'] = date("Y-m-d H:i:s", openssl_to_timestamp($parsed['validFrom']));
		if(isset($parsed['validTo']))
			$data_array['ssl_valid_to'] = date("Y-m-d H:i:s",openssl_to_timestamp($parsed['validTo']));
		if(isset($parsed['subject']['CN']))
			$data_array['ssl_issued_to'] = $parsed['subject']['CN'];
		if(isset($parsed['issuer']['CN']))
			$data_array['ssl_issued_by'] = $parsed['issuer']['CN'];
	}
	$data_array['ssl_checked_at'] = date("Y-m-d H:i:s");
	if(is_array($data_array))
	{
		update_subdomain_table($data_array, $host, $domain);
		if($spit_out)
		{
			echo "<pre>"; print_r($data_array); echo"</pre>";
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////

?>
