<?php
/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2010-2011 Softnik Technologies
// Version 0.1.11 2011-01-15
/////////////////////////////////////////////////////////////////////////////////////////////////////////

require_once("version.php");

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function show_simple_head($title="Domain Portfolio Manager", $desc="")
{
?>
	<head>
		<title><?php echo $title; ?></title>
		<meta http-equiv="Content-Language" content="en">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<link type="text/css" href="lib/css/default.css" rel="stylesheet" media="all">
		<style type="text/css">
		p {
			font-family: 'Trebuchet MS', 'Lucida Sans Unicode', verdana, arial, helvetica, sans-serif;
			padding: 0px;
			font-size: 0.90em;
		}
		img {border:none; margin:0; padding:0; }
		.nomargin {margin:0px;}
		.headerbox
		{
			margin-top: 40px;
			margin-left: auto;
			margin-right: auto;
			width: 600px;
			padding: 10px;
			padding-top: 16px;
			border: 0px solid #808080;
			background-color: #000;
		}
		.boundbox
		{
			margin-top: 5px;
			margin-left: auto;
			margin-right: auto;
			width: 600px;
			padding: 10px;
			border: 0px solid #808080;
			background-color: #EFEFFF;
			text-align: center;
		}
		.footerbox
		{
			margin-top: 5px;
			margin-left: auto;
			margin-right: auto;
			width: 600px;
			padding: 10px;
			border: 0px solid #808080;
			background-color: #EFEFEF;
			font-size: 90%;
			text-align: center;
		}
		</style>

	</head>
<?php
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_base_dir()
{
	return realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . "../../") . DIRECTORY_SEPARATOR;
}
/////////////////////////////////////////////////////////////////////////////////////////

function show_head($jqtheme="redmond", $what="domaintable", $title="Domain Portfolio Manager", $desc="")
{
	global $ui_theme;
	
	if($title == "")
		$title = "Domain Portfolio Manager";
	if($jqtheme == "")
		$jqtheme = $ui_theme;
	if($what == "")
		$what = "domaintable";
	$what = str_replace(" ", "", strtolower($what));
	
	$panesjs = "panes.js";
	if(!file_exists(get_base_dir() . "lib/php/datagrid.php"))
		$panesjs = "panes.std.js";
?>
	<head>
		<title><?php echo $title; ?></title>
		<meta http-equiv="Content-Language" content="en">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

		<link type="text/css" href="lib/css/jqueryui/<?php echo $jqtheme; ?>/jquery-ui-1.8.7.custom.css" rel="stylesheet">
		<link type="text/css" href="lib/css/jqueryui/<?php echo $jqtheme; ?>/splitter.1.51.css" rel="stylesheet" media="screen">
		<link type="text/css" href="lib/css/jqueryui/splitter.1.51.css" rel="stylesheet" media="screen">
		<link type="text/css" href="lib/css/jqueryui/ui.jqgrid.css" rel="stylesheet" media="screen">

		<script type="text/javascript" src="lib/js/jquery/jquery-1.5.1.min.js"></script>
		<script type="text/javascript" src="lib/js/jquery/jquery.cookie.min.js"></script>
		<script type="text/javascript" src="lib/js/jquery/jquery-ui-1.8.7.noeffects.min.js"></script>
		<script type="text/javascript" src="lib/js/jquery/splitter.1.51.min.js"></script>
		<script type="text/javascript" src="lib/js/jquery/i18n/grid.locale-en.js"></script>
		<script type="text/javascript" src="lib/js/jquery/jquery.jqGrid.3.8.2.min.js"></script>
		
		<link type="text/css" href="lib/css/default.css" rel="stylesheet" media="all">
		<link type="text/css" href="lib/css/<?php echo $jqtheme; ?>.css" rel="stylesheet" media="all">
		<?php
		if($what == "domaintable")
		{
		?>
        <script type="text/javascript" src="lib/js/<?php echo $panesjs; ?>"></script>
		<script type="text/javascript" src="lib/js/grid.js"></script>
		<script type="text/javascript" src="lib/js/buttons.js"></script>
		<script type="text/javascript" src="lib/js/add.js"></script>
		<?php
		}
		?>	
	</head>
<?php
}

/////////////////////////////////////////////////////////////////////////////////////////

function show_domain_table()
{
	global $ui_logo_mode;
?>
	<body>
		<div id="header">
<?php 
			if(!file_exists(get_base_dir() . "lib/php/datagrid.php") && $ui_logo_mode == "trial") 
{
?>
			<div class="mainlogo demo">&nbsp;</div>
<?php
}
else
{
?>
			<div class="mainlogo">&nbsp;</div>
<?php
}
?>
			<div class="navbar">
					<button id="adddomains"></button>
					<button id="deldomains"></button>
					&nbsp;&nbsp;
					<button id="bulkaction"></button>
					&nbsp;&nbsp;
					<button id="dates"></button>
					<button id="http"></button>
					<button id="registrar"></button>
					<button id="network"></button>
					<button id="sitepop"></button>
					<button id="notes"></button>
					<button id="ipinfo"></button>
					&nbsp;&nbsp;
					<button id="config"></button>
					&nbsp;&nbsp;
					&nbsp;&nbsp;
					<button id="home"></button>
					<button id="products"></button>
					<button id="support"></button>
					<button id="contact"></button>
			</div>
			<div class="clear">&nbsp;</div>
		</div>

		<div id="SplitterPane">
			<div id="CategoryPane">
				<div class="Padded10">
					<div id="LeftPane">
						<div id="CategoryTabView" style="overflow: auto;">
							<ul>
								<li><a href="#domaincategories">Main</a></li>
								<li><a href="#automaticviews">Auto</a></li>
							</ul>
							<div id="domaincategories" style="padding:0px;padding-top:2px;">
								<table id="DomainCategoryTable"></table>
								<div id="pagerCatView"></div>
							</div>
							<div id="automaticviews" style="padding:0px;padding-top:2px;">
								<table id="DomainQueryTable"></table>
								<div id="pagerQueryView"></div>
							</div>
						</div>
						<div class="clear">&nbsp;</div>
					</div> <!-- #LeftPane -->
				</div>
			</div> <!-- #CategoryPane -->
		  
			<div id="RightPane">
				<div id="DomainTablePane">
					<div class="Padded10">
						<!-- alphabet navbar here -->
						<table id="DomainTableGrid"></table>
						<div id="DomainTablePager"></div>
					</div>
				</div>
			
				<div id="DetailsPane">
					<div class="Padded10">
						<div id="DomainDetailTabView" style="overflow: auto;">
								<ul>
									<li><a href="#registrywhois">Raw Registry Whois</a></li>
									<li><a href="#registrarwhois">Raw Registrar Whois</a></li>
									<li><a href="#subdomains">Sub-domains</a></li>
									<li><a href="#ipdata">IP Whois Data</a></li>
									<li><a href="#about">About</a></li>
								</ul>
								<div id="registrywhois">&nbsp;</div>
								<div id="registrarwhois">&nbsp;</div>
								<div id="ipdata">&nbsp;</div>
								<div id="subdomains">
									<table id="SubDomainTable"></table>
									<div id="pagerSubDomainView"></div>
								</div>
								<div id="about">
									<h3>Watch My Domains SED</h3>
									<hr>
									<div id="version_build_date"><p><?php echo get_version_and_build_date(); ?></p></div>
								</div>
							</div>
						</div>
						<div class="clear">&nbsp;</div>
				</div> <!-- #DetailsPane -->
			</div> <!-- #RightPane -->
		</div> <!-- #SplitterPane -->
		
		
		<div id="dialog-add-domains" title="Add Domains">
			<form id="domain-entry-form">
			<div style="padding: 10px; text-align:center;">
				<label for="ui_domain_names" id="domain_names_label">Domain Names To Add (one entry per line)</label>
				<br><br>
				<textarea rows="15" id="ui_domain_names" name="ui_domain_names" cols="40"></textarea>
			</div>
			</form>
		</div>
		
		<div id="dialog-add-subdomains" title="Add Sub-domains">
			<form id="subdomains-entry-form">
			<div style="padding: 10px; text-align:center;">
				<label for="ui_subdomains" id="subdomains_label">Sub-domains To Add to all selected domains (Don't enter the full hostname. Enter only www, ssl, ftp, etc.)</label>
				<br><br>
				<textarea rows="15" id="ui_subdomains" name="ui_subdomains" cols="40"></textarea>
			</div>
			</form>
		</div>
		
		<div id="dialog-lookup-what" title="Domain Lookups">
			<p>Please select what to queue for lookup.</p>
			<hr>
			<form id="lookup-what-form">
			<div style="padding: 10px;">
				<input type="checkbox" id="luwhois"><label for="luwhois">Domain Whois</label><br>
				<input type="checkbox" id="ludns"><label for="ludns">DNS Check</label><br>
				<input type="checkbox" id="luhttp"><label for="luhttp">Home Page (htp)</label><br>
				<input type="checkbox" id="lualexa"><label for="lualexa">Alexa Info</label><br>
				<input type="checkbox" id="lugpr"><label for="lugpr">Google PR</label><br>
				<input type="checkbox" id="lumx"><label for="lumx">MX Records</label><br>
				<input type="checkbox" id="luping"><label for="luping">Ping Response</label><br>
				<input type="checkbox" id="luipwhois"><label for="luipwhois">IP Whois</label><br>
			</div>
			</form>
		</div>
		
		<div id="dialog-bulk-action" title="Bulk Action Tool">
			<form id="bulk-action-form">
				<div style="padding: 2px;">
					<h4>Add notes &amp; categorize selected domain(s).</h4>
					<br>
					<label for notes_a>Notes-A: &nbsp;</label>
					<input type="text" name="notes_a" id="bt-notes-a"><br><br>
					<label for notes_b>Notes-B: &nbsp;</label>
					<input type="text" name="notes_b" id="bt-notes-b"><br><br>
					<label for notes_c>Notes-C: &nbsp;</label>
					<input type="text" name="notes_b" id="bt-notes-c"><br><br>
					<label for notes_d>Notes-D: &nbsp;</label>
					<input type="text" name="notes_d" id="bt-notes-d"><br><br>
					<br>
					<label for cat_add>Add to Category: &nbsp;</label>
					<input type="text" name="cat_add" size="30" id="bt-cat-add"><br><br>
					<label for cat_delete>Remove from Category: &nbsp;</label>
					<input type="text" name="cat_delete" size="30" id="bt-cat-delete"><br>
					<br>
					<div id="bt-domain-info"></div>
					<p class="warning">Please be careful with this tool. It is very easy to mistakenly overwrite the 
					note columns while using this. Double check all the entries before pressing 'OK'.</p>
				</div>
			</form>
		</div>
	</body>
<?php
}

/////////////////////////////////////////////////////////////////////////////////////////

function show_domain_manager($jqtheme="", $title="", $desc="")
{
session_start();
if(!isset($_SESSION['logged']))
{
	$_SESSION['logged'] = true;
	$_SESSION['id'] = $_SERVER["REMOTE_ADDR"];
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"> 
<html>
<?php	
	show_head($jqtheme, "domaintable", $title, $desc);
	show_domain_table();
?>
</html>
<?php
}

/////////////////////////////////////////////////////////////////////////////////////////

function show_page($status, $title)
{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"> 
<html>
<?php
	$image_path = get_base_path() . "lib/css/img/v4logo300.black-tie.gif";
	show_simple_head($title);
	echo "<body>\n";
	echo "<div class=\"headerbox\">";
	echo "<center><a href=\"http://www.domainpunch.com/\"><img src=\"" . $image_path . "\" width=\"300\" height=\"34\"></a></center>\n";
	echo "</div>";
	echo "<div class=\"boundbox\">";
	$i = 0;
	for($i = 0; $i < count($status); $i++)
	{
		echo "<p>" . $status[$i] . "</p>";
	}
	echo "</div>";
	echo "<div class=\"footerbox\">";
	echo "<p class=\"nomargin\">" . "<a href=\"http://www.softnik.com/\">Softnik Technologies</a>";
	echo "&nbsp;&nbsp;|&nbsp;&nbsp;";
	echo "<a href=\"http://www.domainpunch.com/watch-my-domains-sed/\">Watch My Domains Server Edition</a>";
	echo "</p>";
	echo "</div>";
	echo "</body>\n";
?>
</html>
<?php	
}


/////////////////////////////////////////////////////////////////////////////////////////

function show_success_page($status)
{
	show_page($status, "Success");
}

/////////////////////////////////////////////////////////////////////////////////////////

function show_error_page($status)
{
	show_page($status, "Problem");
}

/////////////////////////////////////////////////////////////////////////////////////////

?>
